%
% Calcul d'enveloppes  partir de l'image I
%


function [EnvMin,EnvMax,nbMin,nbMax]=CalculEnveloppes(I,methode,seuilExtrema,marge)

% disp('Calcul d une enveloppe')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Initialisation des variables

% interpolation efectue sur une image plus grande
taille=length(I)+2*marge;
EnvMin=zeros(taille);
EnvMax=zeros(taille);
nbMin=0;
nbMax=0;

% Calcul des points  interpoler
[Xmin,Ymin,Zmin,Xmax,Ymax,Zmax,nbPointsRajoutes]=grilleInterpolation(I,marge);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Interpolation des minima

nbMin=length(Zmax);

if (nbMin<seuilExtrema+nbPointsRajoutes)
  EnvMin=I;EnvMax=I;TropPeuExtrema=true;
  return;
else  
  EnvMin=interpolation(Xmin,Ymin,Zmin,taille,marge,methode);
  
 
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Interpolation des maxima
nbMax=length(Zmax);

if (nbMax<seuilExtrema+nbPointsRajoutes)
  EnvMin=I;EnvMax=I;TropPeuExtrema=true;
  return;
else
  EnvMax=interpolation(Xmax,Ymax,Zmax,taille,marge,methode);


end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
EnvMax=max(EnvMin,EnvMax);
EnvMin=min(EnvMin,EnvMax);


