function [Iaugmentee]=MatriceAugmentee(I,marge)


% On ajoute des points de manire symtrique
% aux bords et aux coins
% 
% Entre: matrice de taille n^2
% Sortie: matrice taille (n+2*marge)^2
%


n=length(I);
N=n+2*marge;
Iaugmentee=zeros(N);

% valeurs  rajouter
FenetreGauche=I(1:n       , marge:-1:1);
FenetreDroite=I(1:n       , n:-1:n-marge+1);
FenetreHaute=I(marge:-1:1 , 1:n);
FenetreBasse=I(n:-1:n-marge+1  , 1:n);;

CoinHG=I(marge:-1:1,marge:-1:1);
CoinHD=I(marge:-1:1,n:-1:n-marge+1);
CoinBG=I(n:-1:n-marge+1,marge:-1:1);
CoinBD=I(n:-1:n-marge+1,n:-1:n-marge+1);



% Centre de l'image
Iaugmentee(1+marge:n+marge,1+marge:n+marge)=I;

% Coins
Iaugmentee(1:marge     , 1:marge  )=CoinHG;
Iaugmentee(1:marge     , N-marge+1:N)=CoinHD;
Iaugmentee(N-marge+1:N , 1:marge  )=CoinBG;
Iaugmentee(N-marge+1:N , N-marge+1:N)=CoinBD;

% Bords
Iaugmentee(marge+1:N-marge , 1:marge    )=FenetreGauche;
Iaugmentee(marge+1:N-marge , N-marge+1:N)=FenetreDroite;

Iaugmentee(1:marge , marge+1:N-marge)=FenetreHaute;
Iaugmentee(N-marge+1:N , marge+1:N-marge)=FenetreBasse;

