


% comparaison du temps de calcul

tailles=[128,256,512,1024];

randn('state',0);

for taille=tailles


bruit=randn(taille,taille);


%methode='cubic';
methode='thin-plate';
noModeMax=10;
noIterMax=11;
messages=false;
typeAffichage='';
seuilExtrema=taille/8;
marge=taille/8;

tic
[Imodes,Ires,TF]=emd2d(bruit, ...
			 messages,typeAffichage,...
			 methode,noModeMax,noIterMax,...
			 seuilExtrema,marge);
tps=toc;

disp(['n=' num2str(taille) ' Temps de calcul:  ' num2str(tps)])


end



%%%%%%%%%%%%%%%%%%%%%%
% Resultats obtenus
% 11 itrations par mode
%
% 
% taille   Cubic    TPS
% 16        3.4641   7.0896 
% 32        5.4132  21.7527
% 64       13.9583  1674.7072
% 128      44.1367
% 256     186.9598
% 512     871.4193
% 1024
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 3 itrations par mode
%
%         cubic    TPS
% 16    0.96088    1.8793
% 32    2.3531     6.1458
% 64    3.669     56.8280
% 128   9.9564     
% 256   43.6976    
% 512  185.3289    
% 1024 
% 
