function marge=calculMarge(I)

% 
% calcule une marge adapte  l'image
% 0<marge<taille(I)
%

N2=length(I);
nbMin=nnz(imregionalmin(I));
nbMax=nnz(imregionalmax(I));

margeMin=ceil(sqrt(N2/nbMin));
margeMax=ceil(sqrt(N2/nbMax));

marge=max([4,margeMin,margeMax]);
marge=min(marge,length(I));


