
n=500;

pointsBase=[1,1;n,1;1,n;n,n; n/2,n/2 ; n/4,n/4 ; n/4,3*n/4 ; 3*n/4,n/4; 3*n/4,3*n/4  ]';
valeursBase=[-1 , 1,  1,  1 ,    10    ,    -5    ,     5     ,  8  , 12 ];


%pointsBase=[1,1;n,1;1,n;n,n;  n/4,3*n/4 ; 3*n/4,n/4; 3*n/4,3*n/4  ]';
%valeursBase=[1 , 1,  1,  1 ,   5    ,    5     ,  10  ];


lignesTensoriel=[1,n/4,n/2,3*n/4,n];
colonnesTensoriel=[1,n/4,n/2,3*n/4,n];

%matriceBase=zeros(n);
%matriceBase(1,1)=1;
%matriceBase(n,1)=1;
%matriceBase(1,n)=1;
%matriceBase(n,n)=1;
%matriceBase(n/2,n/2)=1;


%I=randn(n);
%[Imin,Imax]=grilleInterpolation(I);
%[x,y,z] = find(Imin);
%pointsBase=[x';y'];
%valeursBase=z';


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% griddata
[X,Y]=meshgrid(pointsBase);
intervalle=1:n;

x=pointsBase(1,:);
y=pointsBase(2,:);
z=valeursBase;

% pour le calcul
[XI,YI]=meshgrid(intervalle);

tic
ZIcubique=griddata(x,y,z,XI,YI,'cubic');
tempsGriddata=toc

verif=[ZIcubique(1,1),ZIcubique(n,1),ZIcubique(1,n),ZIcubique(n,1),ZIcubique(n,n),...
ZIcubique(n/2,n/2),ZIcubique(n/4,n/4),ZIcubique(3*n/4,n/4),ZIcubique(n/4,3*n/4),ZIcubique(3*n/4,3*n/4)]


% pour que le graphe ait une bonne allure
% echantillonage
delta=10;
echantillon=[1,5+delta:delta:n,n];

[Xtrace,Ytrace]=meshgrid(echantillon);

Ztrace=ZIcubique(echantillon,echantillon);


figure(1)
surf(Xtrace,Ytrace,Ztrace)
colorbar

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% produit tensoriel 

%[lignesTensoriel,colonnesTensoriel]=grilleTensoriel(matriceBase);

[Xt,Yt]=meshgrid(lignesTensoriel,colonnesTensoriel);
grilleReguliere={lignesTensoriel,colonnesTensoriel};

tic
valeursGrilleReguliere=griddata(pointsBase(1,:),pointsBase(2,:),valeursBase,Xt,Yt,'linear');
modeleSplineTensoriel=csaps(grilleReguliere,valeursGrilleReguliere,1);
tempsSpline=toc

verifSPT=fnval(modeleSplineTensoriel,pointsBase)
figure(2)
fnplt(modeleSplineTensoriel)
colorbar

% Thin plate
%points={pointsBase(1,:),pointsBase(2,:)};
points=pointsBase;
valeurs=valeursBase;
tic
modeleTPS=tpaps(points,valeurs,1);
tempsThinPlate=toc
figure
resultatTPS=fnplt(modeleTPS,{[1 n] [1 n]});

verifTPS=fnval(modeleTPS,pointsBase)
figure(3)
fnplt(modeleTPS,{[1 n] [1 n]})
colorbar

%surf(valeursTPS{1},valeursTPS{2},valeursTPS{3})



%return

%%%%%%%%%%%%%%%%%%%%%%%%
% Triangulation
x=pointsBase(1,:);
y=pointsBase(2,:);
z=valeursBase;
tri = delaunay(x,y);

figure
trimesh(tri,x,y,z,'EdgeColor','Blue')

figure
triplot(tri,x,y)
line(x,y,'LineStyle','none','Marker','o','Color','r')


figure
plot(x,y,'LineStyle','none','Marker','o','Color','r')
line([1:n],1,'Color','blue')
line([1:n],n/4,'Color','blue')
line([1:n],n/2,'Color','blue')
line([1:n],3*n/4,'Color','blue')
line([1:n],n,'Color','blue')

line(1,[1:n],'Color','blue')
line(n/4,[1:n],'Color','blue')
line(n/2,[1:n],'Color','blue')
line(3*n/4,[1:n],'Color','blue')
line(n,[1:n],'Color','blue')





