
function [enveloppe]=interpolation(pointsX,pointsY,pointsZ,taille,marge,methode)


if strcmp(methode,'thin-plate')

centres=[pointsX,pointsY]';
valeurs=[pointsZ]';

modele=tpaps(centres,valeurs);

for ligne=1:taille
  endroit=[ligne*ones(1,taille);1:taille];
  enveloppe(ligne,:)=fnval(modele,endroit);
end


elseif strcmp(methode,'cubic')

coord1=pointsX';
coord2=pointsY';
valeurs=pointsZ';
[XI,YI]=meshgrid([1:taille],[1:taille]);

enveloppe=griddata(coord1,coord2,valeurs,XI,YI,'cubic')';

elseif strcmp(methode,'linear')

coord1=pointsX';
coord2=pointsY';
valeurs=pointsZ';
[XI,YI]=meshgrid([1:taille],[1:taille]);

enveloppe=griddata(coord1,coord2,valeurs,XI,YI,'linear')';


else

disp('Methode d interpolation non connue')
enveloppe=[];

end

%mesh(enveloppe)
%pause(0.5)
enveloppe=MatriceDiminuee(enveloppe,marge);



