


% nb d'extrema de lena en fonction de la taille de l'image

% image originale: 512*512
data=imread('/users/these/damerval/StageDEA/Matlab/lena.png');
data=data(:,:,1);

echelle512=data;
echelle256=imresize(data,[256 256]);
echelle128=imresize(data,[128 128]);
echelle64=imresize(data,[64 64]);
echelle32=imresize(data,[32 32]);
echelle16=imresize(data,[16 16]);
echelle8=imresize(data,[8 8]);

nbmin512=sum(sum(imregionalmin(echelle512)));
nbmin256=sum(sum(imregionalmin(echelle256)));
nbmin128=sum(sum(imregionalmin(echelle128)));
nbmin64=sum(sum(imregionalmin(echelle64)));
nbmin32=sum(sum(imregionalmin(echelle32)));
nbmin16=sum(sum(imregionalmin(echelle16)));
nbmin8=sum(sum(imregionalmin(echelle8)));

nbmax512=sum(sum(imregionalmax(echelle512)));
nbmax256=sum(sum(imregionalmax(echelle256)));
nbmax128=sum(sum(imregionalmax(echelle128)));
nbmax64=sum(sum(imregionalmax(echelle64)));
nbmax32=sum(sum(imregionalmax(echelle32)));
nbmax16=sum(sum(imregionalmax(echelle16)));
nbmax8=sum(sum(imregionalmax(echelle8)));

t=[8,16,32,64,128,256,512];
nbmax=[nbmax8,nbmax16,nbmax32,nbmax64,nbmax128,nbmax256,nbmax512];
nbmin=[nbmin8,nbmin16,nbmin32,nbmin64,nbmin128,nbmin256,nbmin512];

plot(t,nbmin)
line(t,nbmax)


